// #autoload
// #name = FilterMsg
// #version = 0.99.7
// #date = April 21, 2001
// #author = Robert Blanchet
// #warrior = xgalaxy
// #email = xgalaxy@home.com
// #web = none
// #description = Filters death messages from chat
// #status = beta
// #include = support/file_tools.cs
// #include = scripts/autoexec/panamajack/PJSupport1.cs
// #include = FilterMsg/filterMessages.cs
// #readme = FilterMsg/Readme.txt
// #config = FilterMsgOptions

//-----------------------------------------------------------------------------
//Loading and Saving of Preferences
//-----------------------------------------------------------------------------
$FilterMsgSettings = "FilterMsg/FilterPrefs.txt";
$CurrentFilterMsgLine = "-1"; //dont touch

function FilterMsgOptions::onWake(%this) {
	if(isFile($FilterMsgSettings)) {
       		%file = new FileObject();
       		
        	$FilterPref::ColorMe = %file.getContents($FilterMsgSettings, 2, 2);
        	$FilterPref::ColorNames = %file.getContents($FilterMsgSettings, 3, 3);
        	$FilterPref::TransparantHud = %file.getContents($FilterMsgSettings, 4, 4);
        	
        	ColorMeRdo.setValue($FilterPref::ColorMe);
        	ColorNamesRdo.setValue($FilterPref::ColorNames);
        	TransparantHudRdo.setValue($FilterPref::TransparantHud);
        	%file.close();
        	%file.delete();
        }
        else {  //damnit! the file isn't there so we have to create it
        	export("$FilterMsgSettings", $FilterMsgSettings, False);

        }
}

function FilterMsgOptions::save(%this) {
        %file = new FileObject();
        %file.replaceLine( $FilterMsgSettings, $FilterPref::ColorMe, 2 );
        %file.replaceLine( $FilterMsgSettings, $FilterPref::ColorNames, 3 );
        %file.replaceLine( $FilterMsgSettings, $FilterPref::TransparantHud, 4 );
        %file.close();
        %file.delete();
}

function getTeamName(%name, %detag) {
	
	if(%detag == 1)
		%name = detag(%name);
		
	%id = getClientId(%name, %detag);
	%team = getClientTeamName(%id, %detag);
	return %team;
}
//-----------------------------------------------------------------------------
//Cleans the hud so it looks all purty
//-----------------------------------------------------------------------------
function cleanupFilterMsg(%force) {

	if(($CurrentFilterMsgLine == "-1") || %force == 1)
		for ( %i = 0; %i < (4); %i++ ) {
			%cleanup = "addFilter" @ (%i);
			%cleanup.setValue(""); 
			$CurrentFilterMsgLine = "0";
		}
}

//-----------------------------------------------------------------------------
//Adds the messages(including icons) to the FilterMsg hud
//-----------------------------------------------------------------------------
function sendFilteredMessage(%message) {
	
	cleanupFilterMsg(0);
	
	//Print message until lines are maxed
	if($CurrentFilterMsgLine < 4) {
		%addFilter = "addFilter" @ $CurrentFilterMsgLine;
		%addFilter.setValue(%message);
	 	$CurrentFilterMsgLine++;
	}
	//Since lines are maxed move up each line and replace
	else {
		for ( %i = 1; %i < (4); %i++ ) {
			%addFilter = "addFilter" @ (%i-1);
			%addFilter2 = "addFilter" @ %i;
			%addFilter.setValue(%addFilter2.getValue()); 
		}
		%addFilter = "addFilter" @ 4-1;
		%addFilter.setValue(%message);
	}
}
//-----------------------------------------------------------------------------
//The guts to the Options Tab
//-----------------------------------------------------------------------------
function FilterMsgOptions() {
	if( !isObject(FilterMsgOptions) ) {
			
        new GuiControl(FilterMsgOptions) {
        	profile = "GuiDefaultProfile";
        	horizSizing = "width";
        	vertSizing = "height";
        	position = "0 10";
        	extent = "400 310";
        	minExtent = "8 8";
        	visible = "1";
        	helpTag = "0";
			
			new ShellToggleButton(ColorMeRdo) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "50 20";
				extent = "127 27";
				minExtent = "26 27";
				visible = "1";
				helpTag = "0";
				variable = "$FilterPref::ColorMe";
				text = "Color Me Different";
				maxLength = "255";
				groupNum = "2";
			};
			
			new ShellToggleButton(ColorNamesRdo) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "50 40";
				extent = "127 27";
				minExtent = "26 27";
				visible = "1";
				helpTag = "0";
				variable = "$FilterPref::ColorNames";
				text = "Color Names";
				maxLength = "255";
				groupNum = "3";
			};
			
			new ShellToggleButton(TransparantHudRdo) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "50 60";
				extent = "127 30";
				minExtent = "26 27";
				visible = "1";
				helpTag = "0";
				variable = "$FilterPref::TransparantHud";
				text = "Transparant Hud";
				maxLength = "255";
				groupNum = "4";
			};

    			new ShellBitmapButton(FilterMsgSaveBtn) {
    				profile = "ShellButtonProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "20 270"; // 76 270
    				extent = "85 38";
    				minExtent = "32 38";
    				visible = "1";
    				command = "FilterMsgOptions.save();";
    				helpTag = "0";
    				text = "SAVE";
    				simpleStyle = "0";
    			};
    		};
	}
}

//-----------------------------------------------------------------------------
//Build the FilterMsg Hud
//-----------------------------------------------------------------------------
function FilterMsgHudBuild() {
	
	FilterMsg.delete();
	// Thanks to Zen		
	if(isFile($FilterMsgSettings)) {
       		%file = new FileObject();
        	$FilterPref::ColorMe = %file.getContents($FilterMsgSettings, 2, 2);
        	$FilterPref::ColorNames = %file.getContents($FilterMsgSettings, 3, 3);
        	$FilterPref::TransparantHud = %file.getContents($FilterMsgSettings, 4, 4);
        	
        	ColorMeRdo.setValue($FilterPref::ColorMe);
        	ColorNamesRdo.setValue($FilterPref::ColorNames);
        	TransparantHudRdo.setValue($FilterPref::TransparantHud);
        	
        	%file.close();
        	%file.delete();
        }

	if($FilterPref::TransparantHud == 1)
		%argvark = "GuiConsoleProfile";
	else
		%argvark = "GuiChatBackProfile";
	
	new ShellFieldCtrl(FilterMsg) {
		profile = %argvark;
		horizSizing = "Right";
		vertSizing = "bottom";
		position = "1 355";
		extent = "276 72";
		minExtent = "76 72";
		visible = "1";
	};
	PlayGui.add(FilterMsg);

	//Dynamically build this object
	for ( %i = 0; %i < (4); %i++ ) {
		%msgYCoord = (%i * 18);
		%msgCoords = "2 " @ %msgYCoord;
		%addFilter = "addFilter" @ %i;
		new GuiMLTextCtrl(%addFilter) {
			profile = "GuiTextObjHudLeftProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = %msgCoords;
			extent = "276 18";
			minExtent = "8 8";
			visible = "1";
		};
		FilterMsg.add(%addFilter);
      	}
}	
//-----------------------------------------------------------------------------	
//Start packaging scripts we need to use
//-----------------------------------------------------------------------------
package FilterMsg {

function defaultMessageCallback(%msgType, %msgString, %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType) {
	
	//strip variables of tags
	%MymsgType = detag(%msgType);
	%MymsgString = detag(%msgString);
	
	//for filterMessages.cs
	%weapon = $FilterTypeText[%damageType];
	
	//for grabing clientid of the players
	%MyvictimName = detag(%victimName);
	%MykillerName = detag(%killerName);
	%id = getClientId(%MykillerName);
	
	//grabs the team names of the players
	%victimTeam = getTeamName(%MyvictimName);
	%killerTeam = getTeamName(%MykillerName);
//-----------------------------------------------------------------------------
//Assign values to determine teams, then color their names
//-----------------------------------------------------------------------------
	if(getFriendlyTeam() !$= "Unassigned") {
		
		//Override color values if its you
		if($FilterPref::ColorMe == 1) {
			if(%MyvictimName $= getManagerName())
				%MyvictimName = "<color:9DA03D>" @ %MyvictimName;
			if(%MykillerName $= getManagerName())
				%MykillerName = "<color:9DA03D>" @ %MykillerName;
		}
			
		//Assign color values
		if(%victimTeam $= getFriendlyTeam()) {
			%victimTeam = "0";
			if($FilterPref::ColorNames == 1)
				%MyvictimName = "<color:00dc00>" @ %MyvictimName;
		}
		else {
			%victimTeam = "1";
			if($FilterPref::ColorNames == 1)
				%MyvictimName = "<color:D73333>" @ %MyvictimName;
		}
		if(%killerTeam $= getFriendlyTeam()) {
			%killerTeam = "0";
			if($FilterPref::ColorNames == 1)
				%MykillerName = "<color:00dc00>" @ %MykillerName;
		}
		else {
			%killerTeam = "1";
			if($FilterPref::ColorNames == 1)
				%MykillerName = "<color:D73333>" @ %MykillerName;
		}
	}
	else {
		%victimTeam = "2";
		%killerTeam = "2";
		if($FilterPref::ColorNames == 1) {
			%MyvictimName = "<color:FFFFFF>" @ %MyvictimName;
			%MykillerName = "<color:ADABAB>" @ %MykillerName;
		}
	}
//-----------------------------------------------------------------------------
//The guts of filtering Messages
//-----------------------------------------------------------------------------
 
		switch$ (%MymsgType) {
			
			case "MsgLegitKill":
				if((%weapon !$= "default")) //was causing blank lines to appear
					%message = %MykillerName @ $FilterMsgDeath[%weapon, %killerTeam] @ %MyvictimName;
			
			case "msgTurretKill":
				if(%id > 0) { 
					if(%killerTeam !$= %victimTeam)
						%message = %MykillerName @ $FilterMsgTurretKill[%weapon, %killerTeam] @ %MyvictimName;
					else
						%message = %MykillerName @ $FilterMsgTurretTeamKill[%weapon, %killerTeam] @ %MyvictimName;
				}
				else
					%message = $FilterMsgTurretKill[%weapon, %victimTeam] @ %MyvictimName;
					
			case "msgCTurretKill":
				if(%id > 0) { 
					if(%killerTeam !$= %victimTeam)
						%message = %MykillerName @ $FilterMsgTurretKill[%weapon, %killerTeam] @ %MyvictimName;
					else
						%message = %MykillerName @ $FilterMsgTurretTeamKill[%weapon, %killerTeam] @ %MyvictimName;
				}
				else
					%message = $FilterMsgTurretKill[%weapon, %victimTeam] @ %MyvictimName;
					
			case "MsgHeadshotKill":
				if((%weapon !$= "default")) //was causing blank lines to appear
					%message = %MykillerName @ $FilterMsgHeadshot[%weapon, %killerTeam] @ %MyvictimName;
			
			case "msgVehicleKill":
				if(%id > 0)
					%message = %MykillerName @ $FilterMsgVehicle[%killerTeam] @ %MyvictimName;
				else 
					%message = $FilterMsgVehicle[%victimTeam] @ %MyvictimName;
					
			case "msgTeamKill":
				if((%weapon !$= "default")) //was causing blank lines to appear
					%message = %MykillerName @ $FilterMsgTeamKill[%killerTeam] @ %MyvictimName;
			
			case "msgSuicide":
				%message = $FilterMsgSuicide[%victimTeam] @ %MyvictimName;
				
			case "msgSelfKill":
				%message = $FilterMsgSuicide[%victimTeam] @ %MyvictimName;
				
			case "msgVehicleSpawnKill":
				%message = $FilterMsgVehPad[%victimTeam] @ %MyvictimName;
				
			case "msgOOBKill":
				%message = $FilterMsgOOB[%victimTeam] @ %MyvictimName;
				
			case "msgCampKill":
				%message = $FilterMsgCamping[%victimTeam] @ %MyvictimName;
				
			case "msgLavaKill":
				%message = $FilterMsgLava[%victimTeam] @ %MyvictimName;
				
			case "msgLightningKill":
				%message = $FilterMsgLightning[%victimTeam] @ %MyvictimName;
				
			case "msgExplosionKill":
				%message = $FilterMsgExplosion[%victimTeam] @ %MyvictimName;
				
			case "msgTurretSelfKill":
				%message = $FilterMsgTurretSelfKill[%victimTeam] @ %MyvictimName;
				
			default:
				Parent::defaultMessageCallback(%msgType, %msgString, %victimname, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %weapon);
		}

		if(%message !$= "")
			sendFilteredMessage(%message);
}

function ClientCmdDisplayHuds() {
	
	parent::ClientCmdDisplayHuds();
	//Toggles visibility of the FilterMsg Hud
	switch$ ($HudMode) {
		
		case "Pilot":
			FilterMsg.setVisible(true);
			
		case "Passenger":
		 	FilterMsg.setVisible(true);
		
		case "Object":
			FilterMsg.setVisible(true);
		
		case "Observer":
			FilterMsg.setVisible(true);
			
		case "PickTeam":
			FilterMsg.setVisible(false);
			
		default:
			FilterMsg.setVisible(true);
	}
}

function clientCmdMissionEnd(%seq) {
	
	parent::clientCmdMissionEnd(%seq);
	$CurrentFilterMsgLine = "-1";
	cleanupFilterMsg(1);
}

function DispatchLaunchMode() {
	
	cleanupFilterMSg(1);
	parent::DispatchLaunchMode();
		
}

function LoadingGui::onWake(%this) { //changed from LoadingGui
	
	if (!$FilterHudcreated)
	{
		FilterMsgHudBuild();
		
		if(isObject(HM) && isObject(HudMover))
			hudmover::addhud(FilterMsg, "FilterMsg");
		
		$FilterHudcreated = true;
	}
	
	parent::onWake(%this);
}

function OptionsDlg::applyGraphicChanges(%this) {
	
	parent::applyGraphicChanges(%this);
	$CurrentFilterMsgLine = "-1"; //dont touch
	PlayGui.remove(FilterMsg);
	FilterMsg.delete();
	FilterMsgHudBuild();
}

function lobbyLeaveGame() {
	
	FilterMsgOptions.save();
	parent::lobbyLeaveGame();
}

};

FilterMsgOptions(); 
activatePackage(FilterMsg);

//-----------------------------------------------------------------------------
//End
//-----------------------------------------------------------------------------