// Regions Popup 1.0 by {USB}Spiderman
// Email: halsmalltalker@hotmail.com

// Changes the Regions mask to a nice little popup menu.

// If you know how to change the text in the popup to look like everything else, please let me know.

new ShellPopupMenu(RegionsPopup) {
	profile = "ShellPopupProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "235 -3";
	extent = "195 36";
	minExtent = "49 36";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	maxLength = "255";
	maxPopupHeight = "200";
	buttonBitmap = "gui/shll_pulldown";
	rolloverBarBitmap = "gui/shll_pulldownbar_rol";
	selectedBarBitmap = "gui/shll_pulldownbar_act";
	noButtonStyle = "0";
};

package RegionsPopup {


	function RegionsPopupSetup() {
		if (isObject(GMJ_FilterText))
			GMJ_FilterText.delete();

		GM_JoinPane.remove(RegionsPopup);
		GM_JoinPane.add(RegionsPopup);
		
		RegionsPopup.clear();
		
		%allRegions = "All Regions";
		%eastRegion = "East Region";
		%westRegion = "West Region";
		%saRegion = "South America";
		%aussieRegion = "Austrailia";
		%asiaRegion = "Asia";
		%euroRegion = "Europe";

		%allRegionsId = 0;
		%eastRegionId = 1;
		%westRegionId = 2;
		%saRegionId = 3;
		%aussieRegionId = 4;
		%asiaRegionId = 5;
		%euroRegionId = 6;

		RegionsPopup.add(%allRegions, %allRegionsId, 1);       // 63
		RegionsPopup.add(%eastRegion, %eastRegionId, 1);       // 1
		RegionsPopup.add(%westRegion, %westRegionId, 1);       // 2
		RegionsPopup.add(%saRegion, %saRegionId, 1);           // 4
		RegionsPopup.add(%aussieRegion, %aussieRegionId, 1);   // 8
		RegionsPopup.add(%asiaRegion, %asiaRegionId, 1);       // 16
		RegionsPopup.add(%euroRegion, %euroRegionId, 1);       // 32

		if ($pref::Net::RegionMask == 63)
			RegionsPopup.setSelected(%allRegions);
		else if ($pref::Net::RegionMask == 1)
			RegionsPopup.setSelected(%eastRegion);
		else if ($pref::Net::RegionMask == 2)
			RegionsPopup.setSelected(%westRegion);
		else if ($pref::Net::RegionMask == 4)
			RegionsPopup.setSelected(%saRegion);
		else if ($pref::Net::RegionMask == 8)
			RegionsPopup.setSelected(%aussieRegion);
		else if ($pref::Net::RegionMask == 16)
			RegionsPopup.setSelected(%asiaRegion);
		else if ($pref::Net::RegionMask == 32)
			RegionsPopup.setSelected(%euroRegion);

	}

	function GameGui::onWake(%this) {
		parent::onWake(%this);
		RegionsPopupSetup();
	}

	function ChooseFilterDlg::onSleep(%this) {
		parent::onSleep(%this);

		RegionsPopupSetup();
	}

	function RegionsPopup::onSelect(%this, %id, %text) {
		
		// set the selected item as the current filter
		if (%id == 0)
			$pref::Net::RegionMask = "63";
		else if (%id == 1)
			$pref::Net::RegionMask = "1";
		else if (%id == 2)
			$pref::Net::RegionMask = "2";
		else if (%id == 3)
			$pref::Net::RegionMask = "4";
		else if (%id == 4)
			$pref::Net::RegionMask = "8";
		else if (%id == 5)
			$pref::Net::RegionMask = "16";
		else if (%id == 6)
			$pref::Net::RegionMask = "32";
		GMJ_Browser.runQuery();
	}


}; //package RegionsPopup

activatePackage(RegionsPopup);
